diff --git a/lib/librte_eal/bsdapp/eal/eal.c b/lib/librte_eal/bsdapp/eal/eal.c
index 8599a35..81d1a65 100644
--- a/lib/librte_eal/bsdapp/eal/eal.c
+++ b/lib/librte_eal/bsdapp/eal/eal.c
@@ -613,30 +613,23 @@ eal_parse_args(int argc, char **argv)
 		case 0:
 			if (!strcmp(lgopts[option_index].name, OPT_NO_HUGE)) {
 				internal_config.no_hugetlbfs = 1;
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_NO_PCI)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_NO_PCI)) {
 				internal_config.no_pci = 1;
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_NO_HPET)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_NO_HPET)) {
 				internal_config.no_hpet = 1;
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_VMWARE_TSC_MAP)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_VMWARE_TSC_MAP)) {
 				internal_config.vmware_tsc_map = 1;
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_NO_SHCONF)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_NO_SHCONF)) {
 				internal_config.no_shconf = 1;
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_PROC_TYPE)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_PROC_TYPE)) {
 				internal_config.process_type = eal_parse_proc_type(optarg);
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_VDEV)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_VDEV)) {
 				if (rte_eal_devargs_add(RTE_DEVTYPE_VIRTUAL,
 						optarg) < 0) {
 					eal_usage(prgname);
 					return -1;
 				}
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_SYSLOG)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_SYSLOG)) {
 				if (eal_parse_syslog(optarg) < 0) {
 					RTE_LOG(ERR, EAL, "invalid parameters for --"
 							OPT_SYSLOG "\n");
diff --git a/lib/librte_eal/linuxapp/eal/eal.c b/lib/librte_eal/linuxapp/eal/eal.c
index 655c454..3393550 100644
--- a/lib/librte_eal/linuxapp/eal/eal.c
+++ b/lib/librte_eal/linuxapp/eal/eal.c
@@ -839,8 +839,7 @@ eal_parse_args(int argc, char **argv)
 		case 0:
 			if (!strcmp(lgopts[option_index].name, OPT_NO_HUGE)) {
 				internal_config.no_hugetlbfs = 1;
-			}
-			if (!strcmp(lgopts[option_index].name, OPT_XEN_DOM0)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_XEN_DOM0)) {
 		#ifdef RTE_LIBRTE_XEN_DOM0
 				internal_config.xen_dom0_support = 1;
 		#else
@@ -849,44 +848,34 @@ eal_parse_args(int argc, char **argv)
 					" RTE_LIBRTE_XEN_DOM0=y\n");
 				return -1;
 		#endif
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_NO_PCI)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_NO_PCI)) {
 				internal_config.no_pci = 1;
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_NO_HPET)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_NO_HPET)) {
 				internal_config.no_hpet = 1;
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_VMWARE_TSC_MAP)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_VMWARE_TSC_MAP)) {
 				internal_config.vmware_tsc_map = 1;
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_NO_SHCONF)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_NO_SHCONF)) {
 				internal_config.no_shconf = 1;
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_HUGE_DIR)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_HUGE_DIR)) {
 				internal_config.hugepage_dir = optarg;
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_PROC_TYPE)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_PROC_TYPE)) {
 				internal_config.process_type = eal_parse_proc_type(optarg);
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_FILE_PREFIX)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_FILE_PREFIX)) {
 				internal_config.hugefile_prefix = optarg;
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_SOCKET_MEM)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_SOCKET_MEM)) {
 				if (eal_parse_socket_mem(optarg) < 0) {
 					RTE_LOG(ERR, EAL, "invalid parameters for --"
 							OPT_SOCKET_MEM "\n");
 					eal_usage(prgname);
 					return -1;
 				}
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_VDEV)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_VDEV)) {
 				if (rte_eal_devargs_add(RTE_DEVTYPE_VIRTUAL,
 						optarg) < 0) {
 					eal_usage(prgname);
 					return -1;
 				}
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_SYSLOG)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_SYSLOG)) {
 				if (eal_parse_syslog(optarg) < 0) {
 					RTE_LOG(ERR, EAL, "invalid parameters for --"
 							OPT_SYSLOG "\n");
@@ -905,24 +894,21 @@ eal_parse_args(int argc, char **argv)
 					return -1;
 				}
 				internal_config.log_level = log;
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_BASE_VIRTADDR)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_BASE_VIRTADDR)) {
 				if (eal_parse_base_virtaddr(optarg) < 0) {
 					RTE_LOG(ERR, EAL, "invalid parameter for --"
 							OPT_BASE_VIRTADDR "\n");
 					eal_usage(prgname);
 					return -1;
 				}
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_VFIO_INTR)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_VFIO_INTR)) {
 				if (eal_parse_vfio_intr(optarg) < 0) {
 					RTE_LOG(ERR, EAL, "invalid parameters for --"
 							OPT_VFIO_INTR "\n");
 					eal_usage(prgname);
 					return -1;
 				}
-			}
-			else if (!strcmp(lgopts[option_index].name, OPT_CREATE_UIO_DEV)) {
+			} else if (!strcmp(lgopts[option_index].name, OPT_CREATE_UIO_DEV)) {
 				internal_config.create_uio_dev = 1;
 			} else {
 				RTE_LOG(ERR, EAL, "Option %s is not supported "